#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <thread>
#include <mutex>
#ifdef WIN32
#include <windows.h>
#else
#include <unistd.h>
#endif

#define CYCLES 5
static int g_count = 0;
//static std::mutex mutex;

void threadFunc(void* data)
{
	int threadIndex = (int)data;
	for (int i = 0; i < CYCLES; i++)
	{
		//mutex.lock();
		printf("thread %d cycle i = %d global count = %d\n", threadIndex, i, g_count);
		g_count++;
		//mutex.unlock();

#ifdef WIN32
		Sleep(1000); // window Sleep
#else
		usleep(1000); // linux usleep
#endif
	}
}


void threadFunc1(void* data)
{
	for (int i = 0; i < CYCLES; i++)
	{
		printf("thread1 cycle i = %d global count = %d\n", i, g_count);
		g_count++; // critical section
#ifdef WIN32
		Sleep(1000); // window Sleep
#else
		usleep(1000); // linux usleep
#endif
	}
}

void threadFunc2(void* data)
{
	for (int i = 0; i < CYCLES; i++)
	{
		printf("thread2 cycle i = %d global count = %d\n", i, g_count);
		g_count++; // critical section
#ifdef WIN32
		Sleep(1000); // window Sleep
#else
		usleep(1000); // linux usleep
#endif
	}
}

void threadFunc3(void* data)
{
	for (int i = 0; i < CYCLES; i++)
	{
		printf("thread3 cycle i = %d global count = %d\n", i, g_count);
		g_count++; // critical section
#ifdef WIN32
		Sleep(1000); // window Sleep
#else
		usleep(1000); // linux usleep
#endif
	}
}

int main(int argc, char** argv)
{
	std::thread th[3];

	//th[0] = std::thread(threadFunc1, (void*)NULL);
	//th[1] = std::thread(threadFunc2, (void*)NULL);
	//th[2] = std::thread(threadFunc3, (void*)NULL);
	int index = 1;
	th[0] = std::thread(threadFunc, (void*)index);
	index = 2;
	th[1] = std::thread(threadFunc, (void*)index);
	index = 3;
	th[2] = std::thread(threadFunc, (void*)index);


	for (int i = 0; i < 2*CYCLES; i++)
	{
		printf("main cycle count = %d\n", i);
#ifdef WIN32
		Sleep(1000); // window Sleep
#else
		usleep(1000); // linux usleep
#endif
	}

	th[0].detach();
	th[1].detach();
	th[2].detach();

	//return 0;
}